import App
import Foundation
import LoadQBautostart

mode = Foundation.MutatorDef("QBautostart Extension V0.5")
EngineeringInit = 0

# QuickBattle
#Foundation.OverrideDef.EngineeringExtension = Foundation.OverrideDef("EngineeringExtension", "QuickBattle.QuickBattle.SetupEventHandlers", "EngineeringExtension.QBSetupEventHandlers", dict = { "modes": [ mode ] } )
#Foundation.OverrideDef.EngineeringExtension = Foundation.OverrideDef("EngineeringExtension", "QuickBattle.QuickBattle.StartSimulationAction", "EngineeringExtension.QBStartSimulationAction", dict = { "modes": [ mode ] } )
#Foundation.OverrideDef.EngineeringExtension = Foundation.OverrideDef("EngineeringExtension", "QuickBattle.QuickBattle.RecreatePlayer", "EngineeringExtension.QBRecreatePlayer", dict = { "modes": [ mode ] } )

# QuickBattle Replacement
#Foundation.OverrideDef.EngineeringExtension = Foundation.OverrideDef("EngineeringExtension", "Custom.QuickBattleGame.QuickBattle.SetupEventHandlers", "EngineeringExtension.QBRSetupEventHandlers", dict = { "modes": [ mode ] } )
#Foundation.OverrideDef.EngineeringExtension = Foundation.OverrideDef("EngineeringExtension", "Custom.QuickBattleGame.QuickBattle.StartSimulation", "EngineeringExtension.QBRStartSimulation", dict = { "modes": [ mode ] } )


class EngineeringExtensionTrigger_init(Foundation.TriggerDef):
	def __init__(self, name, eventKey, dict = {}):
            Foundation.TriggerDef.__init__(self, name, eventKey, dict)
            global EngineeringInit
            EngineeringInit = 0

	def __call__(self, pObject, pEvent, dict = {}):
            global EngineeringInit
            EngineeringInit = 0 # yes yes, evil - will find another way sometimes...!
            #print("Engineering init called")
            if not EngineeringInit:
                LoadQBautostart.ImportQBautostart()
                EngineeringInit = 1


class EngineeringExtensionTrigger_Restart(Foundation.TriggerDef):
	def __init__(self, name, eventKey, dict = {}):
            Foundation.TriggerDef.__init__(self, name, eventKey, dict)

	def __call__(self, pObject, pEvent, dict = {}):
            global EngineeringInit
            if EngineeringInit:
                LoadQBautostart.ImportQBautostart(1)

EngineeringExtensionTrigger_init('Engineering Extension Trigger init', App.ET_MISSION_START, dict = { 'modes': [ mode ] } )
EngineeringExtensionTrigger_Restart('Engineering Extension Trigger Restart', App.ET_SET_PLAYER, dict = { 'modes': [ mode ] } )
